﻿' Project: Hands On Chapter 6
' Author:  Anthony DePinto
' Description: This project inputs sales information for books.  It calculates the extended price and discount for a sale and maintains summary information for all sales.  
'              Uses variables, constants, calculations, error handling and a message box
'
Public Class BookSaleForm

    Private QuantitySumInteger, SaleCountInteger As Integer
    Private DiscountSumDecimal, DiscountedPriceSumDecimal As Decimal
    Const DISCOUNT_RATE_Decimal As Decimal = 0.15D

  
    Private Sub ExitButton_Click(sender As System.Object, e As System.EventArgs) Handles ExitButton.Click
        ' exit program
        Me.Close()
    End Sub

    Private Sub ClearButton_Click(sender As System.Object, e As System.EventArgs) Handles ClearButton.Click
        ' Clear the form
        ResetForm()
    End Sub

    Private Sub CalculateButton_Click(sender As System.Object, e As System.EventArgs) Handles CalculateButton.Click
        Dim QuantityInteger As Integer
        Dim PriceDecimal, ExtendedPriceDecimal, DiscountDecimal, DiscountedPriceDecimal, AverageDiscountDecimal As Decimal

        Try
            ' convert quantity to numeric variable
            QuantityInteger = Integer.Parse(QuantityTextBox.Text)

            Try
                ' convert price if quantity was successful
                PriceDecimal = Decimal.Parse(PriceTextBox.Text)
                ' Calculate values for sale
                ExtendedPriceDecimal = CalculatePrice(QuantityInteger, PriceDecimal)
                CalculateDiscount(ExtendedPriceDecimal, DiscountDecimal)
                DiscountedPriceDecimal = ExtendedPriceDecimal - DiscountDecimal

                ' Calculate summary values
                QuantitySumInteger += QuantityInteger
                DiscountSumDecimal += DiscountDecimal
                DiscountedPriceSumDecimal += DiscountedPriceDecimal
                SaleCountInteger += 1
                AverageDiscountDecimal = DiscountSumDecimal / SaleCountInteger

                ' format and display answers for the sale
                ExtendedPriceTextBox.Text = ExtendedPriceDecimal.ToString("C")
                DiscountTextBox.Text = DiscountDecimal.ToString("N")
                DiscountedPriceTextBox.Text = DiscountedPriceDecimal.ToString("C")

                ' format and display summary values
                QuantitySumTextBox.Text = QuantitySumInteger.ToString
                DiscountSumTextBox.Text = DiscountSumDecimal.ToString("C")
                DiscountedAmountSumTextBox.Text = DiscountedPriceSumDecimal.ToString("C")
                AverageDiscountTextBox.Text = AverageDiscountDecimal.ToString("C")

            Catch PriceException As FormatException
                ' handle a price exception
                MessageBox.Show("Price must be numeric.", "Data Entry Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                With PriceTextBox
                    .Focus()
                    .SelectAll()
                End With
            End Try
        Catch QuantityException As FormatException
            ' handle a quantity exception
            MessageBox.Show("Quantity must be numeric.", "Data Entry Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            With QuantityTextBox
                .Focus()
                .SelectAll()
            End With
        Catch AnException As Exception
            ' handle any other exception
            MessageBox.Show("Error: " & AnException.Message)
        End Try
    End Sub

    Sub CalculateDiscount(ByVal ExtendedPriceDecimal As Decimal,
                          ByRef DiscountDecimal As Decimal)


        ' compute amount
        DiscountDecimal = ExtendedPriceDecimal * DISCOUNT_RATE_Decimal

    End Sub
    Function CalculatePrice(QuantityInteger As Integer,
                            PriceDecimal As Decimal) As Decimal
        ' compute extended price
        Dim ExtendedPriceDecimal As Decimal

        ExtendedPriceDecimal = QuantityInteger * PriceDecimal

        Return ExtendedPriceDecimal

    End Function
    Sub ResetForm()
        ' Clear previous amounts from the form
        TitleTextBox.Clear()
        PriceTextBox.Clear()
        ExtendedPriceTextBox.Clear()
        DiscountTextBox.Clear()
        DiscountedPriceTextBox.Clear()
        With QuantityTextBox
            .Clear()
            .Focus()
        End With

    End Sub
End Class
